<?php
// $Id: xoops_version.php,v 1.8 2006/01/15 23:46:30 ohwada Exp $

// 2006-01-14 K.OHWADA
// v0.97

// 2005-11-20 K.OHWADA
// v0.96

// 2005-10-28 K.OHWADA
// v0.95

// 2005-10-20 K.OHWADA
// BUG 3111: timeout occurs in popular site if many top categories
// add template topten_mixed.html
// add config topten_mode

// 2005-09-06 K.OHWADA
// v0.94

// 2005-08-09 K.OHWADA
// v0.93

// 2005-07-18 K.OHWADA
// v0.92

// 2005-02-03 K.OHWADA
// v0.91

// 2005-01-20 K.OHWADA
// v0.9
// add template header.html
// delete xxx_post, url_check, etc
// popular formtype select -> text

// 2004-12-31 K.OHWADA
// add table config

// 2004-11-28 K.OHWADA
// v0.89
// delete post, autopost, mod, automod, rss_auto, ratelink_use

// 2004-11-20 K.OHWADA
// v0.81

// 2004-10-24 K.OHWADA
// mutual site, recommend site
// broken link check
// URL-less mode
// description_type
// ratelink_use
// RSS/ATOM URL

// 2004-08-20 Ryuji
// add category list block

// 2004-08-20 Tom_G3X
// Submenu: category of the first level
// admin can change the display number of subcategory

// 2004/08/10 K.OHWADA
// add table weblinks_catlink
// add block rating
// add config double_post
// add template searchform.html
// delete template submit.html
// enable to install this module two or more. 

//================================================================
// xoops_version.php
// 2004/01/23 K.OHWADA
//================================================================

// enable to install this module two or more.
// --- change dir name ---
$MODULE_DIRNAME = 'weblinks';

$modversion['version'] = '0.97';

$modversion['name'] = _MI_WEBLINKS_NAME;
$modversion['description'] = _MI_WEBLINKS_DESC;
$modversion['credits'] = "Kenichi OHWADA";
$modversion['help'] = "weblinks.html";
$modversion['license'] = "GPL see LICENSE";
$modversion['official'] = 1;
$modversion['image'] = "images/weblinks_slogo.png";
$modversion['dirname'] = $MODULE_DIRNAME;

// All tables should not have any prefix!
$modversion['sqlfile']['mysql'] = "sql/mysql.sql";

// -- Tables created by sql file (without prefix!) ---
$modversion['tables'][0] = $MODULE_DIRNAME."_category";
$modversion['tables'][1] = $MODULE_DIRNAME."_link";
$modversion['tables'][2] = $MODULE_DIRNAME."_modify";
$modversion['tables'][3] = $MODULE_DIRNAME."_broken";
$modversion['tables'][4] = $MODULE_DIRNAME."_votedata";
$modversion['tables'][5] = $MODULE_DIRNAME."_catlink";
$modversion['tables'][6] = $MODULE_DIRNAME."_atomfeed";
$modversion['tables'][7] = $MODULE_DIRNAME."_config";

// Admin things
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "admin/index.php";
$modversion['adminmenu'] = "admin/menu.php";

// Menu
$modversion['hasMain'] = 1;
$modversion['sub'][1]['name'] = _MI_WEBLINKS_SMNAME1;
$modversion['sub'][1]['url'] = "submit.php";
$modversion['sub'][2]['name'] = _MI_WEBLINKS_SMNAME2;
$modversion['sub'][2]['url'] = "topten.php?hit=1";
$modversion['sub'][3]['name'] = _MI_WEBLINKS_SMNAME3;
$modversion['sub'][3]['url'] = "topten.php?rate=1";

// Submenu
// category of the first level by Tom
global $xoopsDB;
$table_link = $xoopsDB->prefix($MODULE_DIRNAME."_category");
$result = $xoopsDB->query("SELECT cid, title FROM ".$xoopsDB->prefix("weblinks_category")." WHERE pid='0' ORDER BY orders, cid");
$i = 4;
while (list($cid, $title) = $xoopsDB->fetchRow($result))
{
	$modversion['sub'][$i]['name'] = " - ".$title;
	$modversion['sub'][$i]['url'] = "viewcat.php?cid=".$cid."";
	$i++;
}

//---------------------------------------------------------
// Comments
//---------------------------------------------------------
// Comments
$modversion['hasComments'] = 1;
$modversion['comments']['itemName'] = 'lid';
$modversion['comments']['pageName'] = 'singlelink.php';
$modversion['comments']['extraParams'] = array('cid');

// Comment callback functions
$modversion['comments']['callbackFile'] = 'include/comment_functions.php';
$modversion['comments']['callback']['approve'] = $MODULE_DIRNAME."_com_approve";
$modversion['comments']['callback']['update']  = $MODULE_DIRNAME."_com_update";

//---------------------------------------------------------
//  Search 
//---------------------------------------------------------
$modversion['hasSearch'] = 1;
$modversion['search']['file'] = "include/search.inc.php";
$modversion['search']['func'] = $MODULE_DIRNAME."_search";

//---------------------------------------------------------
//  Blocks 
//---------------------------------------------------------

$weblinks_top_show_func  = "b_".$MODULE_DIRNAME."_top_show";
$weblinks_top_edit_func  = "b_".$MODULE_DIRNAME."_top_edit";

$modversion['blocks'][1]['file'] = "weblinks_top.php";
$modversion['blocks'][1]['name'] = _MI_WEBLINKS_BNAME1;
$modversion['blocks'][1]['description'] = "Shows recently added web links";
$modversion['blocks'][1]['show_func'] = $weblinks_top_show_func;
$modversion['blocks'][1]['edit_func'] = $weblinks_top_edit_func;
$modversion['blocks'][1]['template']  = $MODULE_DIRNAME."_block_new.html";
$modversion['blocks'][1]['options'] = "time_update|10|30|7|0|50|50";

$modversion['blocks'][2]['file'] = "weblinks_top.php";
$modversion['blocks'][2]['name'] = _MI_WEBLINKS_BNAME2;
$modversion['blocks'][2]['description'] = "Shows most visited web links";
$modversion['blocks'][2]['show_func'] = $weblinks_top_show_func;
$modversion['blocks'][2]['edit_func'] = $weblinks_top_edit_func;
$modversion['blocks'][2]['template']  = $MODULE_DIRNAME."_block_top.html";
$modversion['blocks'][2]['options'] = "hits|10|30|7|0|50|50";

// add rating block
$modversion['blocks'][3]['file'] = "weblinks_top.php";
$modversion['blocks'][3]['name'] = _MI_WEBLINKS_BNAME3;
$modversion['blocks'][3]['description'] = "Shows most rating web links";
$modversion['blocks'][3]['show_func'] = $weblinks_top_show_func;
$modversion['blocks'][3]['edit_func'] = $weblinks_top_edit_func;
$modversion['blocks'][3]['options'] = "rating|10|30|7|0|50|50";

// choice old temmplate, if you can't view correctly.
//$modversion['blocks'][3]['template']  = $MODULE_DIRNAME."_block_top.html";
$modversion['blocks'][3]['template']  = $MODULE_DIRNAME."_block_rate.html";

// add category list block by Ryuji
$modversion['blocks'][4]['file'] = "weblinks_catlist.php";
$modversion['blocks'][4]['name'] = _MI_WEBLINKS_BNAME4;
$modversion['blocks'][4]['description'] = "Shows category list";
$modversion['blocks'][4]['show_func'] = "b_".$MODULE_DIRNAME."_catlist_show";
$modversion['blocks'][4]['edit_func'] = "b_".$MODULE_DIRNAME."_catlist_edit";
$modversion['blocks'][4]['template']  = $MODULE_DIRNAME."_block_catlist.html";
$modversion['blocks'][4]['options'] = "5|1|100|50";

// atomfeed
$modversion['blocks'][5]['file'] = "weblinks_atomfeed.php";
$modversion['blocks'][5]['name'] = _MI_WEBLINKS_BNAME5;
$modversion['blocks'][5]['description'] = "Shows new atom feed";
$modversion['blocks'][5]['show_func'] = "b_".$MODULE_DIRNAME."_atom_show";
$modversion['blocks'][5]['edit_func'] = "b_".$MODULE_DIRNAME."_atom_edit";
$modversion['blocks'][5]['template']  = $MODULE_DIRNAME."_block_atom.html";
$modversion['blocks'][5]['options'] = "10|40|100";

$modversion['blocks'][6]['file'] = "weblinks_atomfeed.php";
$modversion['blocks'][6]['name'] = _MI_WEBLINKS_BNAME6;
$modversion['blocks'][6]['description'] = "Shows blog";
$modversion['blocks'][6]['show_func'] = "b_".$MODULE_DIRNAME."_blog_show";
$modversion['blocks'][6]['edit_func'] = "b_".$MODULE_DIRNAME."_blog_edit";
$modversion['blocks'][6]['template']  = $MODULE_DIRNAME."_block_blog.html";
$modversion['blocks'][6]['options'] = "0|10|1|200";

//---------------------------------------------------------
// Templates
//---------------------------------------------------------
$modversion['templates'][1]['file'] = $MODULE_DIRNAME."_header.html";
$modversion['templates'][1]['description'] = '';
$modversion['templates'][2]['file'] = $MODULE_DIRNAME."_linklist.html";
$modversion['templates'][2]['description'] = '';
$modversion['templates'][3]['file'] = $MODULE_DIRNAME."_link.html";
$modversion['templates'][3]['description'] = '';
$modversion['templates'][4]['file'] = $MODULE_DIRNAME."_feedsingle.html";
$modversion['templates'][4]['description'] = '';
$modversion['templates'][5]['file'] = $MODULE_DIRNAME."_feedfull.html";
$modversion['templates'][5]['description'] = '';
$modversion['templates'][6]['file'] = $MODULE_DIRNAME."_feedlist.html";
$modversion['templates'][6]['description'] = '';

$modversion['templates'][7]['file'] = $MODULE_DIRNAME."_index.html";
$modversion['templates'][7]['description'] = '';
$modversion['templates'][8]['file'] = $MODULE_DIRNAME."_viewcat.html";
$modversion['templates'][8]['description'] = '';
$modversion['templates'][9]['file'] = $MODULE_DIRNAME."_singlelink.html";
$modversion['templates'][9]['description'] = '';
$modversion['templates'][10]['file'] = $MODULE_DIRNAME."_topten.html";
$modversion['templates'][10]['description'] = '';
$modversion['templates'][11]['file'] = $MODULE_DIRNAME."_ratelink.html";
$modversion['templates'][11]['description'] = '';
$modversion['templates'][12]['file'] = $MODULE_DIRNAME."_brokenlink.html";
$modversion['templates'][12]['description'] = '';
$modversion['templates'][13]['file'] = $MODULE_DIRNAME."_catlist.html";
$modversion['templates'][13]['description'] = '';
$modversion['templates'][14]['file'] = $MODULE_DIRNAME."_search.html";
$modversion['templates'][14]['description'] = '';
$modversion['templates'][15]['file'] = $MODULE_DIRNAME."_passwd.html";
$modversion['templates'][15]['description'] = '';
$modversion['templates'][16]['file'] = $MODULE_DIRNAME."_viewmark.html";
$modversion['templates'][16]['description'] = '';
$modversion['templates'][17]['file'] = $MODULE_DIRNAME."_viewfeed.html";
$modversion['templates'][17]['description'] = '';
$modversion['templates'][18]['file'] = $MODULE_DIRNAME."_rss_build.html";
$modversion['templates'][18]['description'] = '';
$modversion['templates'][19]['file'] = $MODULE_DIRNAME."_atom_build.html";
$modversion['templates'][19]['description'] = '';

// BUG 3111: timeout occurs in popular site if many top categories
$modversion['templates'][20]['file'] = $MODULE_DIRNAME."_topten_mixed.html";
$modversion['templates'][20]['description'] = '';


//---------------------------------------------------------
// Config Settings
// only for modules that need config settings generated automatically
//---------------------------------------------------------

$modversion['config'][1]['name'] = 'logoshow';
$modversion['config'][1]['title'] = '_MI_WEBLINKS_LOGOSHOW';
$modversion['config'][1]['description'] = '_MI_WEBLINKS_LOGOSHOWDSC';
$modversion['config'][1]['formtype'] = 'yesno';
$modversion['config'][1]['valuetype'] = 'int';
$modversion['config'][1]['default'] = 1;

$modversion['config'][2]['name'] = 'titleshow';
$modversion['config'][2]['title'] = '_MI_WEBLINKS_TITLESHOW';
$modversion['config'][2]['description'] = '_MI_WEBLINKS_TITLESHOWDSC';
$modversion['config'][2]['formtype'] = 'yesno';
$modversion['config'][2]['valuetype'] = 'int';
$modversion['config'][2]['default'] = 1;

$modversion['config'][3]['name'] = 'popular';
$modversion['config'][3]['title'] = '_MI_WEBLINKS_POPULAR';
$modversion['config'][3]['description'] = '_MI_WEBLINKS_POPULARDSC';
$modversion['config'][3]['formtype'] = 'textbox';
$modversion['config'][3]['valuetype'] = 'int';
$modversion['config'][3]['default'] = 100;

$modversion['config'][4]['name'] = 'newdays';
$modversion['config'][4]['title'] = '_MI_WEBLINKS_NEWDAYS';
$modversion['config'][4]['description'] = '_MI_WEBLINKS_NEWDAYS_DSC';
$modversion['config'][4]['formtype'] = 'textbox';
$modversion['config'][4]['valuetype'] = 'int';
$modversion['config'][4]['default'] = 7;

$modversion['config'][5]['name'] = 'newlinks';
$modversion['config'][5]['title'] = '_MI_WEBLINKS_NEWLINKS';
$modversion['config'][5]['description'] = '_MI_WEBLINKS_NEWLINKSDSC';
$modversion['config'][5]['formtype'] = 'select';
$modversion['config'][5]['valuetype'] = 'int';
$modversion['config'][5]['default'] = 20;
$modversion['config'][5]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][6]['name'] = 'perpage';
$modversion['config'][6]['title'] = '_MI_WEBLINKS_PERPAGE';
$modversion['config'][6]['description'] = '_MI_WEBLINKS_PERPAGEDSC';
$modversion['config'][6]['formtype'] = 'select';
$modversion['config'][6]['valuetype'] = 'int';
$modversion['config'][6]['default'] = 10;
$modversion['config'][6]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][7]['name'] = 'descshort';
$modversion['config'][7]['title'] = '_MI_WEBLINKS_DESCSHORT';
$modversion['config'][7]['description'] = '_MI_WEBLINKS_DESCSHORTDSC';
$modversion['config'][7]['formtype'] = 'textbox';
$modversion['config'][7]['valuetype'] = 'int';
$modversion['config'][7]['default'] = 100;

$modversion['config'][8]['name'] = 'orderby';
$modversion['config'][8]['title'] = '_MI_WEBLINKS_ORDERBY';
$modversion['config'][8]['description'] = '_MI_WEBLINKS_ORDERBYDSC';
$modversion['config'][8]['formtype'] = 'select';
$modversion['config'][8]['valuetype'] = 'int';
$modversion['config'][8]['default'] = 0;
$modversion['config'][8]['options'] = array(
	'_MI_WEBLINKS_ORDERBY0' => 0,
	'_MI_WEBLINKS_ORDERBY1' => 1,
	'_MI_WEBLINKS_ORDERBY2' => 2,
	'_MI_WEBLINKS_ORDERBY3' => 3,
	'_MI_WEBLINKS_ORDERBY4' => 4,
	'_MI_WEBLINKS_ORDERBY5' => 5,
	'_MI_WEBLINKS_ORDERBY6' => 6,
	'_MI_WEBLINKS_ORDERBY7' => 7);

$modversion['config'][9]['name'] = 'search_links';
$modversion['config'][9]['title'] = '_MI_WEBLINKS_SEARCH_LINKS';
$modversion['config'][9]['description'] = '_MI_WEBLINKS_SEARCH_LINKSDSC';
$modversion['config'][9]['formtype'] = 'select';
$modversion['config'][9]['valuetype'] = 'int';
$modversion['config'][9]['default'] = 20;
$modversion['config'][9]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][10]['name'] = 'search_min';
$modversion['config'][10]['title'] = '_MI_WEBLINKS_SEARCH_MIN';
$modversion['config'][10]['description'] = '_MI_WEBLINKS_SEARCH_MINDSC';
$modversion['config'][10]['formtype'] = 'textbox';
$modversion['config'][10]['valuetype'] = 'int';
$modversion['config'][10]['default'] = 5;

$modversion['config'][11]['name'] = 'frame';
$modversion['config'][11]['title'] = '_MI_WEBLINKS_USEFRAMES';
$modversion['config'][11]['description'] = '_MI_WEBLINKS_USEFRAMEDSC';
$modversion['config'][11]['formtype'] = 'yesno';
$modversion['config'][11]['valuetype'] = 'int';
$modversion['config'][11]['default'] = 0;

$modversion['config'][12]['name'] = 'broken';
$modversion['config'][12]['title'] = '_MI_WEBLINKS_BROKEN';
$modversion['config'][12]['description'] = '_MI_WEBLINKS_BROKENDSC';
$modversion['config'][12]['formtype'] = 'textbox';
$modversion['config'][12]['valuetype'] = 'int';
$modversion['config'][12]['default'] = 5;

$modversion['config'][13]['name'] = 'listimage_use';
$modversion['config'][13]['title'] = '_MI_WEBLINKS_LISTIMAGE_USE';
$modversion['config'][13]['description'] = '_MI_WEBLINKS_LISTIMAGE_USEDSC';
$modversion['config'][13]['formtype'] = 'yesno';
$modversion['config'][13]['valuetype'] = 'int';
$modversion['config'][13]['default'] = 1;

$modversion['config'][14]['name'] = 'listimage_width';
$modversion['config'][14]['title'] = '_MI_WEBLINKS_LISTIMAGE_WIDTH';
$modversion['config'][14]['description'] = '';
$modversion['config'][14]['formtype'] = 'textbox';
$modversion['config'][14]['valuetype'] = 'int';
$modversion['config'][14]['default'] = 100;

$modversion['config'][15]['name'] = 'listimage_height';
$modversion['config'][15]['title'] = '_MI_WEBLINKS_LISTIMAGE_HEIGHT';
$modversion['config'][15]['description'] = '';
$modversion['config'][15]['formtype'] = 'textbox';
$modversion['config'][15]['valuetype'] = 'int';
$modversion['config'][15]['default'] = 60;

$modversion['config'][16]['name'] = 'linkimage_use';
$modversion['config'][16]['title'] = '_MI_WEBLINKS_LINKIMAGE_USE';
$modversion['config'][16]['description'] = '_MI_WEBLINKS_LINKIMAGE_USEDSC';
$modversion['config'][16]['formtype'] = 'yesno';
$modversion['config'][16]['valuetype'] = 'int';
$modversion['config'][16]['default'] = 1;

$modversion['config'][17]['name'] = 'linkimage_width';
$modversion['config'][17]['title'] = '_MI_WEBLINKS_LINKIMAGE_WIDTH';
$modversion['config'][17]['description'] = '';
$modversion['config'][17]['formtype'] = 'textbox';
$modversion['config'][17]['valuetype'] = 'int';
$modversion['config'][17]['default'] = 150;

$modversion['config'][18]['name'] = 'linkimage_height';
$modversion['config'][18]['title'] = '_MI_WEBLINKS_LINKIMAGE_HEIGHT';
$modversion['config'][18]['description'] = '';
$modversion['config'][18]['formtype'] = 'textbox';
$modversion['config'][18]['valuetype'] = 'int';
$modversion['config'][18]['default'] = 200;

// BUG 3111: timeout occurs in popular site if many top categories
$modversion['config'][19]['name'] = 'topten_style';
$modversion['config'][19]['title'] = '_MI_WEBLINKS_TOPTEN_STYLE';
$modversion['config'][19]['description'] = '_MI_WEBLINKS_TOPTEN_STYLE_DSC';
$modversion['config'][19]['formtype'] = 'select';
$modversion['config'][19]['valuetype'] = 'int';
$modversion['config'][19]['default'] = 0;
$modversion['config'][19]['options'] = array(
	'_MI_WEBLINKS_TOPTEN_STYLE_0' => 0,
	'_MI_WEBLINKS_TOPTEN_STYLE_1' => 1);

$modversion['config'][20]['name'] = 'topten_links';
$modversion['config'][20]['title'] = '_MI_WEBLINKS_TOPTEN_LINKS';
$modversion['config'][20]['description'] = '_MI_WEBLINKS_TOPTEN_LINKS_DSC';
$modversion['config'][20]['formtype'] = 'textbox';
$modversion['config'][20]['valuetype'] = 'int';
$modversion['config'][20]['default'] = 10;

$modversion['config'][21]['name'] = 'topten_cats';
$modversion['config'][21]['title'] = '_MI_WEBLINKS_TOPTEN_CATS';
$modversion['config'][21]['description'] = '_MI_WEBLINKS_TOPTEN_CATS_DSC';
$modversion['config'][21]['formtype'] = 'textbox';
$modversion['config'][21]['valuetype'] = 'int';
$modversion['config'][21]['default'] = 20;


//---------------------------------------------------------
// Notification
//---------------------------------------------------------
$modversion['hasNotification'] = 1;
$modversion['notification']['lookup_file'] = 'include/notification.inc.php';
$modversion['notification']['lookup_func'] = $MODULE_DIRNAME."_notify_iteminfo";

$modversion['notification']['category'][1]['name'] = 'global';
$modversion['notification']['category'][1]['title'] = _MI_WEBLINKS_GLOBAL_NOTIFY;
$modversion['notification']['category'][1]['description'] = _MI_WEBLINKS_GLOBAL_NOTIFYDSC;
$modversion['notification']['category'][1]['subscribe_from'] = array('index.php','viewcat.php','singlelink.php');

$modversion['notification']['category'][2]['name'] = 'category';
$modversion['notification']['category'][2]['title'] = _MI_WEBLINKS_CATEGORY_NOTIFY;
$modversion['notification']['category'][2]['description'] = _MI_WEBLINKS_CATEGORY_NOTIFYDSC;
$modversion['notification']['category'][2]['subscribe_from'] = array('viewcat.php', 'singlelink.php');
$modversion['notification']['category'][2]['item_name'] = 'cid';
$modversion['notification']['category'][2]['allow_bookmark'] = 1;

$modversion['notification']['category'][3]['name'] = 'link';
$modversion['notification']['category'][3]['title'] = _MI_WEBLINKS_LINK_NOTIFY;
$modversion['notification']['category'][3]['description'] = _MI_WEBLINKS_LINK_NOTIFYDSC;
$modversion['notification']['category'][3]['subscribe_from'] = 'singlelink.php';
$modversion['notification']['category'][3]['item_name'] = 'lid';
$modversion['notification']['category'][3]['allow_bookmark'] = 1;

$modversion['notification']['event'][1]['name'] = 'new_category';
$modversion['notification']['event'][1]['category'] = 'global';
$modversion['notification']['event'][1]['title'] = _MI_WEBLINKS_GLOBAL_NEWCATEGORY_NOTIFY;
$modversion['notification']['event'][1]['caption'] = _MI_WEBLINKS_GLOBAL_NEWCATEGORY_NOTIFYCAP;
$modversion['notification']['event'][1]['description'] = _MI_WEBLINKS_GLOBAL_NEWCATEGORY_NOTIFYDSC;
$modversion['notification']['event'][1]['mail_template'] = 'global_newcategory_notify';
$modversion['notification']['event'][1]['mail_subject'] = _MI_WEBLINKS_GLOBAL_NEWCATEGORY_NOTIFYSBJ;

$modversion['notification']['event'][2]['name'] = 'link_modify';
$modversion['notification']['event'][2]['category'] = 'global';
$modversion['notification']['event'][2]['admin_only'] = 1;
$modversion['notification']['event'][2]['title'] = _MI_WEBLINKS_GLOBAL_LINKMODIFY_NOTIFY;
$modversion['notification']['event'][2]['caption'] = _MI_WEBLINKS_GLOBAL_LINKMODIFY_NOTIFYCAP;
$modversion['notification']['event'][2]['description'] = _MI_WEBLINKS_GLOBAL_LINKMODIFY_NOTIFYDSC;
$modversion['notification']['event'][2]['mail_template'] = 'global_linkmodify_notify';
$modversion['notification']['event'][2]['mail_subject'] = _MI_WEBLINKS_GLOBAL_LINKMODIFY_NOTIFYSBJ;

$modversion['notification']['event'][3]['name'] = 'link_broken';
$modversion['notification']['event'][3]['category'] = 'global';
$modversion['notification']['event'][3]['admin_only'] = 1;
$modversion['notification']['event'][3]['title'] = _MI_WEBLINKS_GLOBAL_LINKBROKEN_NOTIFY;
$modversion['notification']['event'][3]['caption'] = _MI_WEBLINKS_GLOBAL_LINKBROKEN_NOTIFYCAP;
$modversion['notification']['event'][3]['description'] = _MI_WEBLINKS_GLOBAL_LINKBROKEN_NOTIFYDSC;
$modversion['notification']['event'][3]['mail_template'] = 'global_linkbroken_notify';
$modversion['notification']['event'][3]['mail_subject'] = _MI_WEBLINKS_GLOBAL_LINKBROKEN_NOTIFYSBJ;

$modversion['notification']['event'][4]['name'] = 'link_submit';
$modversion['notification']['event'][4]['category'] = 'global';
$modversion['notification']['event'][4]['admin_only'] = 1;
$modversion['notification']['event'][4]['title'] = _MI_WEBLINKS_GLOBAL_LINKSUBMIT_NOTIFY;
$modversion['notification']['event'][4]['caption'] = _MI_WEBLINKS_GLOBAL_LINKSUBMIT_NOTIFYCAP;
$modversion['notification']['event'][4]['description'] = _MI_WEBLINKS_GLOBAL_LINKSUBMIT_NOTIFYDSC;
$modversion['notification']['event'][4]['mail_template'] = 'global_linksubmit_notify';
$modversion['notification']['event'][4]['mail_subject'] = _MI_WEBLINKS_GLOBAL_LINKSUBMIT_NOTIFYSBJ;

$modversion['notification']['event'][5]['name'] = 'new_link';
$modversion['notification']['event'][5]['category'] = 'global';
$modversion['notification']['event'][5]['title'] = _MI_WEBLINKS_GLOBAL_NEWLINK_NOTIFY;
$modversion['notification']['event'][5]['caption'] = _MI_WEBLINKS_GLOBAL_NEWLINK_NOTIFYCAP;
$modversion['notification']['event'][5]['description'] = _MI_WEBLINKS_GLOBAL_NEWLINK_NOTIFYDSC;
$modversion['notification']['event'][5]['mail_template'] = 'global_newlink_notify';
$modversion['notification']['event'][5]['mail_subject'] = _MI_WEBLINKS_GLOBAL_NEWLINK_NOTIFYSBJ;

$modversion['notification']['event'][6]['name'] = 'link_submit';
$modversion['notification']['event'][6]['category'] = 'category';
$modversion['notification']['event'][6]['admin_only'] = 1;
$modversion['notification']['event'][6]['title'] = _MI_WEBLINKS_CATEGORY_LINKSUBMIT_NOTIFY;
$modversion['notification']['event'][6]['caption'] = _MI_WEBLINKS_CATEGORY_LINKSUBMIT_NOTIFYCAP;
$modversion['notification']['event'][6]['description'] = _MI_WEBLINKS_CATEGORY_LINKSUBMIT_NOTIFYDSC;
$modversion['notification']['event'][6]['mail_template'] = 'category_linksubmit_notify';
$modversion['notification']['event'][6]['mail_subject'] = _MI_WEBLINKS_CATEGORY_LINKSUBMIT_NOTIFYSBJ;

$modversion['notification']['event'][7]['name'] = 'new_link';
$modversion['notification']['event'][7]['category'] = 'category';
$modversion['notification']['event'][7]['title'] = _MI_WEBLINKS_CATEGORY_NEWLINK_NOTIFY;
$modversion['notification']['event'][7]['caption'] = _MI_WEBLINKS_CATEGORY_NEWLINK_NOTIFYCAP;
$modversion['notification']['event'][7]['description'] = _MI_WEBLINKS_CATEGORY_NEWLINK_NOTIFYDSC;
$modversion['notification']['event'][7]['mail_template'] = 'category_newlink_notify';
$modversion['notification']['event'][7]['mail_subject'] = _MI_WEBLINKS_CATEGORY_NEWLINK_NOTIFYSBJ;

$modversion['notification']['event'][8]['name'] = 'approve';
$modversion['notification']['event'][8]['category'] = 'link';
$modversion['notification']['event'][8]['invisible'] = 1;
$modversion['notification']['event'][8]['title'] = _MI_WEBLINKS_LINK_APPROVE_NOTIFY;
$modversion['notification']['event'][8]['caption'] = _MI_WEBLINKS_LINK_APPROVE_NOTIFYCAP;
$modversion['notification']['event'][8]['description'] = _MI_WEBLINKS_LINK_APPROVE_NOTIFYDSC;
$modversion['notification']['event'][8]['mail_template'] = 'link_approve_notify';
$modversion['notification']['event'][8]['mail_subject'] = _MI_WEBLINKS_LINK_APPROVE_NOTIFYSBJ;

?>
